<template>
  <div class="messaging-message-list">
    <LoadingSpinner v-if="loading" />
    <PaginationNav
      v-if="showPagination && !overview"
      :total="total"
      :offset="offset"
      :defaultOffset="defaultOffset"
      :limit="limit"
      singular="message"
      plural="messages"
    />
    <div v-for="message in messages" :key="message.id">
      <div
        :key="`datetime_${message.id}`"
        class="messaging-message-datetime"
        v-if="!overview && message.hoursSinceLastMessage > minHours"
      >
        <span data-bs-toggle="tooltip" :title="moment(message.created).format('llll')">{{
          moment(message.created).fromNow()
        }}</span>
      </div>
      <component :key="message.id" :message="message" :is="component(message)" />
    </div>
    <div v-if="loaded && messages.length === 0">No messages found.</div>
    <PaginationNav
      v-if="showPagination && !overview"
      :total="total"
      :offset="offset"
      :defaultOffset="defaultOffset"
      :limit="limit"
      singular="message"
      plural="messages"
    />
    <MessagingMessageListCompose
      id="message-list__compose"
      :username="username"
      v-if="!overview && isLastPage"
      @message-sent="onMessageSent"
    />
  </div>
</template>

<script>
const SHOW_DATETIME_MIN_HOURS = 1

import { ref, computed, onMounted, onUpdated, watch } from 'vue'
import { useStore } from 'vuex'
import { Constants, VideoHelper, LoadingSpinner, PaginationNav, useApi, useMoment, useNotification } from '../../core'
import { useAuth } from '../../identity'
import MessagesApi from '../api/messages-api.js'
import MessagingMessageListItemOverview from './message-list-item-overview.vue'
import MessagingMessageListItemCurrent from './message-list-item-current.vue'
import MessagingMessageListItemOther from './message-list-item-other.vue'
import MessagingMessageListCompose from './message-list-compose.vue'

export default {
  name: 'MessagingMessageList',
  components: {
    LoadingSpinner,
    PaginationNav,
    MessagingMessageListItemOverview,
    MessagingMessageListItemCurrent,
    MessagingMessageListItemOther,
    MessagingMessageListCompose,
  },
  props: {
    username: { type: String, default: '' }, // Optional. If not provided, we show the overview of all conversations.
    offset: { type: Number, default: 0 }, // Default should be 0 in overview mode, but -1 if a username is specified.
    limit: { type: Number, default: Constants.pagination.defaultPageLimit },
  },
  setup(props) {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const moment = useMoment()
    const notify = useNotification()
    const messagesApi = new MessagesApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const messages = ref([])
    const total = ref(0)
    const hasScrolled = ref(false)
    const minHours = ref(SHOW_DATETIME_MIN_HOURS)

    const showPagination = computed(() => {
      return loaded.value && total.value > props.limit
    })

    const overview = computed(() => {
      return !props.username
    })

    const pageCount = computed(() => {
      return Math.ceil(total.value / parseInt(props.limit))
    })

    // The last page is the default page.
    const isLastPage = computed(() => {
      return props.offset === -1 || props.offset === (pageCount.value - 1) * props.limit
    })

    const component = (message) => {
      return overview.value
        ? 'MessagingMessageListItemOverview'
        : message.fromUserId === store.state.identity.session.userId
        ? 'MessagingMessageListItemCurrent'
        : 'MessagingMessageListItemOther'
    }

    const loadAsync = async () => {
      hasScrolled.value = false
      loading.value = true
      loaded.value = false
      messages.value = []

      try {
        const response = overview.value
          ? await messagesApi.fetchConversationsAsync({
              expand: 'all',
              offset: props.offset,
              limit: props.limit,
            })
          : await messagesApi.fetchMessagesAsync(props.username, {
              expand: 'all',
              offset: props.offset,
              limit: props.limit,
            })

        total.value = response.data.total
        messages.value = addMetaData(response.data)
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the messages.', ex)
      } finally {
        loading.value = false
      }
    }

    const onMessageSent = (message) => {
      messages.value.push(message)
      addMetaData(messages.value)
    }

    const addMetaData = (messages) => {
      // Add the hoursSinceLastMessage property to each message and returns the collection.
      let lastMessage = null
      messages.forEach(function (message) {
        let hours = 1000000 // This will effectively always show the first one datetime heading.
        if (lastMessage != null) {
          const from = moment(lastMessage.created)
          const to = moment(message.created)
          const duration = moment.duration(to.diff(from))
          hours = duration.asHours()
        }
        if (lastMessage && hours <= SHOW_DATETIME_MIN_HOURS && lastMessage.fromUserId === message.fromUserId) {
          lastMessage.continues = true
        }
        message.hoursSinceLastMessage = hours
        lastMessage = message
      })
      return messages
    }

    onMounted(async () => {
      await loadAsync()
    })

    onUpdated(async () => {
      if (!overview.value && loaded.value && !hasScrolled.value) {
        VideoHelper.fluidWidth()
        var element = document.querySelector('#message-list__compose')
        if (element) {
          element.scrollIntoView()
        }
        hasScrolled.value = true
      }
    })

    watch(
      () => props.offset,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.limit,
      async () => {
        await loadAsync()
      }
    )

    return {
      moment,
      loading,
      loaded,
      messages,
      total,
      hasScrolled,
      minHours,
      showPagination,
      overview,
      pageCount,
      isLastPage,
      component,
      onMessageSent,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.messaging-message-datetime {
  text-align: center;
  color: vars.$subtextColor;
  padding: vars.$spacing 0;
}

.dark .messaging-message-datetime {
  color: vars.$darkSubtextColor;
}
</style>
